/******************************************************************************
** 									     **
**    Zenobit 1dc0.2 : CITADEL Operating System				     **
**  ---------------------------------------------			     **
**									     **
**    Source: zcapp_avl_create_node.c					     **
**   									     **
**    Purpose:								     **
**	See explanation below.						     **
**									     **
**    Author: DG.Ward.							     **
**									     **
**    Contact:								     **
**	comeherenightmare@hotmail.com					     **
**      warddg1@tekotago.ac.nz						     **
**	kyretzn@gmail.com						     **
**									     **
**    Date: 23th, April 2007						     **
**									     **
******************************************************************************/
#include "zcapp_avl_functions.h"

	// --- create_node
	// *
	// *  purpose:
	// *	To create an initialized node with the requested key.
	// *
	// *  parameters:
	// *	key = desired node key.
	// *
	// *  returns:
 	// *	A pointer to your tasty, new and initialized AVL_NODE_T.
	// *	_ret_failure if the node could not be created.
	// *
	// ---
	avl_node_t *create_node(unsigned int key) {
		avl_node_t *new_node = (avl_node_t*)malloc(sizeof(avl_node_t));
		if(!new_node) return (avl_node_t*)_ret_failure;
		else {
			new_node->balance = _b_b;
			new_node->key = key;
			new_node->paths[_p_u] = 0;
			new_node->paths[_p_l] = 0;
			new_node->paths[_p_r] = 0;

			return new_node;
		}
	}
