/******************************************************************************
** 									     **
**    Zenobit 1dc0.2 : CITADEL Operating System				     **
**  ---------------------------------------------			     **
**									     **
**    Source: zcapp_avl_find_node.c					     **
**   									     **
**    Purpose:								     **
**	See explanation below.						     **
**									     **
**    Author: DG.Ward.							     **
**									     **
**    Contact:								     **
**	comeherenightmare@hotmail.com					     **
**      warddg1@tekotago.ac.nz						     **
**	kyretzn@gmail.com						     **
**									     **
**    Date: 23th, April 2007						     **
**									     **
******************************************************************************/
#include "zcapp_avl_functions.h"

	// --- find_node
	// *
	// *  purpose:
	// *	This handy routine allows you to actually find nodes in your
	// *	glorious tree!
	// *
	// *  parameters:
	// *	tree = Pointer to the Tree pointer. (eg. &test_tree)
	// *	key = Key to locate within the Tree.
	// *0
	// *  returns:
	// *	A pointer to the desired node, if it could be located.
	// *	Otherwise, _ret_failure.
	// *
	// ---
	avl_node_t *find_node(avl_node_t **tree, unsigned int key) {
		if((!tree) || (!*tree)) return (avl_node_t*)_ret_failure;
		else {
			avl_node_t *iterator = *tree;
			unsigned int path = 0;

			while((iterator) && (iterator->key != key)) {
				path = (key > iterator->key);
				iterator = iterator->paths[path];
			}
			return iterator;
		}
	}
