/******************************************************************************
** 									     **
**    Zenobit 1dc0.2 : CITADEL Operating System				     **
**  ---------------------------------------------			     **
**									     **
**    Source: zcapp_avl_rotate_tree.c					     **
**   									     **
**    Purpose:								     **
**	See explanation below.						     **
**									     **
**    Author: DG.Ward.							     **
**									     **
**    Contact:								     **
**	comeherenightmare@hotmail.com					     **
**      warddg1@tekotago.ac.nz						     **
**	kyretzn@gmail.com						     **
**									     **
**    Date: 23th, April 2007						     **
**									     **
******************************************************************************/
#include "zcapp_avl_functions.h"

	// --- rotate_tree
	// *
	// *  purpose:
	// *	This function simply rotates left/right around the given
	// *	Subtree, returning the new Subtree root.
	// *
	// *  parameters:
	// *	subtree = Pointer to a valid AVL_NODE_T.
	// *	direction = _p_l = Rotate left.
	// *		    _p_r = Rotate right.
	// *
	// *  returns:
	// *	A pointer to the new Subtree root.
	// *
	// ---
	avl_node_t *rotate_tree(avl_node_t *subtree, unsigned char direction) {
		avl_node_t *new_root = subtree->paths[!direction];
		subtree->paths[!direction] = new_root->paths[direction];

		if(subtree->paths[!direction])
			subtree->paths[!direction]->paths[_p_u] = subtree;

		new_root->paths[direction] = subtree;

		new_root->paths[_p_u] = subtree->paths[_p_u];
		subtree->paths[_p_u] = new_root;

		return new_root;
	}
