/******************************************************************************
** 									     **
**    Zenobit 1dc0.2 : CITADEL Operating System				     **
**  ---------------------------------------------			     **
**									     **
**    Source: zcapp_avl_structures.h					     **
**   									     **
**    Purpose:								     **
**	Defines the AVL_NODE_T structure.				     **
**									     **
**    Author: DG.Ward.							     **
**									     **
**    Contact:								     **
**	comeherenightmare@hotmail.com					     **
**      warddg1@tekotago.ac.nz						     **
**	kyretzn@gmail.com						     **
**									     **
**    Date: 23th, April 2007						     **
**									     **
******************************************************************************/
#ifndef _h_zcapp_avl_structures
#define _h_zcapp_avl_structures

	/* These definitions make dealing with the Pointers easier */
	#define _p_u	0x2		/* Uplink (Parent link) */
	#define _p_l	0x0		/* Left Child */
	#define _p_r	0x1		/* Right Child */

	/* And these deal with Node balances */
	#define _b_lc	0x0 	/* Left Critical */
	#define _b_lh	0x1 	/* Left Heavy */
	#define _b_b	0x2		/* Balanced */
	#define _b_rh	0x3 	/* Right Heavy */
	#define _b_rc	0x4 	/* Right Critical */

	/* Below, the AVL Node is defined. */
	typedef struct avl_node_def avl_node_t;

	struct avl_node_def {
		avl_node_t *paths[0x3];
		unsigned int key;			/* Under Zenobit, this may not be needed */
		unsigned char balance;		/* Under Zenobit, this is a flag byte */
	};

#endif
