/******************************************************************************
** 									     **
**    Zenobit 1dc0.2 : CITADEL Operating System				     **
**  ---------------------------------------------			     **
**									     **
**    Source: zcapp_avl_upbalance.c					     **
**   									     **
**    Purpose:								     **
**	See explanation below.						     **
**									     **
**    Author: DG.Ward.							     **
**									     **
**    Contact:								     **
**	comeherenightmare@hotmail.com					     **
**      warddg1@tekotago.ac.nz						     **
**	kyretzn@gmail.com						     **
**									     **
**    Date: 23th, April 2007						     **
**									     **
******************************************************************************/
#include "zcapp_avl_functions.h"

	// --- upbalance
	// *
	// *  purpose:
	// *	This function is specifically for updating / correcting the
	// *	tree's balances after a removal operation.
	// *
	// *  parameters:
	// *	tree = Pointer to the Tree's pointer (eg. &test_tree)
	// *	node = The node to begin uptracing from.
	// *	stdir = the starting balance update.
	// *
	// *  returns:
	// *	No returns.
	// *
	// ---
	void upbalance(avl_node_t **tree, avl_node_t *node, unsigned char stdir) {
		avl_node_t *iterator = node;
		unsigned int path = stdir;


		while(1) {
			iterator->balance += (path ? -1 : 1);
			if((iterator->balance == _b_lc) || (iterator->balance == _b_rc)) {
				if(iterator == *tree) {
					*tree = rebalance_tree(iterator, _m_rem);
					return;
				} else {
					path = (iterator->key > iterator->paths[_p_u]->key);

					iterator = iterator->paths[_p_u]->paths[path] = \
						rebalance_tree(iterator->paths[_p_u]->paths[path], _m_rem);
				}
			}
			if((iterator->balance == _b_lh) || (iterator->balance == _b_rh)) break;
			else if(iterator == *tree) break;
			else {
				path = (iterator->key > iterator->paths[_p_u]->key);
				iterator = iterator->paths[_p_u];
			}
		}
	}
